program test;
type
   s3=0..7;
   prvec=array [s3] of real;
var
  i,j:integer;

function LastBit(x:s3):integer; begin LastBit:=x mod 2; end;
function FirstBit(x:s3):integer; begin FirstBit:=x div 4; end;
function MiddleBit(x:s3):integer; begin MiddleBit:=(x mod 4) div 2; end;

function AddBit (x:s3;b:integer):s3;
begin
  AddBit:= (x mod 4)*2+b;
end;

function ProbBeforeAfter(x,y,z:s3; nit:integer):real;
   {prob. to meet x before y, if starting with z}
begin
  assert(x<>y);
  if nit=0 then begin
    ProbBeforeAfter:=0.5;
  end else begin
    if x=z then begin
      ProbBeforeAfter:=1;
    end else if y=z then begin
      ProbBeforeAfter:=0;
    end else begin
      ProbBeforeAfter:=0.5*ProbBeforeAfter(x,y,AddBit(z,0),nit-1)+
                       0.5*ProbBeforeAfter(x,y,AddBit(z,1),nit-1);
    end;
  end;
end;

function ProbBefore(x,y:s3; nit:integer):real;
   {prob. to meet x before y}
var
  t:s3; sum: real;
begin;
  sum:=0;
  for t:=0 to 7 do begin
    sum:=sum+ProbBeforeAfter(x,y,t,nit);
  end;
  ProbBefore:=sum/8;
end;

procedure outstr3(x:s3);
begin
  write(FirstBit(x));
  write(MiddleBit(x));
  write(LastBit(x));
end;

begin
  for j:=0 to 7 do begin
    for i:=0 to 7 do begin
      if i<>j then begin
        write('Meeting '); outstr3(i); write(' before '); outstr3(j); write(' with probability ');
        writeln(ProbBefore(i,j,25):5:6);
      end;
    end;
    writeln;
  end;
end.
